<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      :add-button-text="dictionaryRu.add_button_title"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      custom-class="modal-md"
      :is-show-pagination="!newStatus"
      :is-show-controls="false"
    >
      <custom-union
        :data-source="selectedData"
        :api="api"
        :modal="$refs.viewItem"
        @submit="preparedSave"
        @delete="onDelete"
        @refresh="onRefresh"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import itemMixin   from '@/mixins/dictionaries/edit-item'
import paging      from '@/mixins/dictionaries/paging'

import SinglePane  from 'common-components/src/obComponents/obSinglePanels'
import ObModal     from 'common-components/src/obComponents/obModal'
import ObTable     from 'common-components/src/obComponents/obTable'
import CustomUnion from './modal/CustomUnion'

import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__common__customs_unions'

export default {
  name: 'CustomsUnions',
  components: {
    ObModal,
    CustomUnion,
    SinglePane,
    ObTable
  },
  mixins: [
    paging,
    itemMixin
  ],
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'name'
        },
        {
          title: this.dictionaryRu.columns.international_name,
          key: 'international_name'
        },
        {
          title: this.dictionaryRu.columns.abbr_name,
          key: 'short_name'
        },
        {
          title: this.dictionaryRu.columns.member_countries,
          key: 'members',
          allowSorting: false,
          html: data => {
            if (!data.members && !data.members.length) return '';

            let members = data.members.reduce((previous, item) => {
              return previous + item.denomination + ', ';
            }, '');

            if (members.length > 2) {
              members = members.slice(0, members.length - 2);
            }

            return members;
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          allowSorting: false,
          html: data => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive;
          }
        }
      ];
    }
  },
  data() {
    return {
      newData: {
        international_name: '',
        members: [],
        members_uuid: [],
        name: '',
        short_name: ''
      },
      dataGridRefName: 'CustomsUnions',
      members: [],
      api: {
        source: '/oboz2-dictionary-customs-unions-crud/v1/'
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    };
  },
  methods: {
    async onSelectionItem(data) {
      this.newStatus = false

      try {
        const _data = await this.eiGet(data);
        this.selectedData = _data.data;
        this.$set(
          this.selectedData,
          'members_uuid',
          this.selectedData.members.map(member => {
            return member.uuid;
          })
        );
        this.$refs.viewItem.open()
      }
      catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }

    },
    preparedSave(payload) {
      this.selectedData.members = this.selectedData.members_uuid;
      delete this.selectedData['members_uuid'];
      this.onSave(payload);
    }
  }
};
</script>